﻿using FluentBlazorApp.DTOs;
using FluentBlazorApp.Responses;
using static FluentBlazorApp.Responses.CustomResponses;

namespace FluentBlazorApp.Services
{
    public class AccountService : IAccountService
    {
        private readonly HttpClient _httpClient;
        private readonly string BASE_URL = "api/account";

        public AccountService(HttpClient httpClient)
        {
            _httpClient = httpClient;
        }

        public async Task<LoginResponse> LoginAsync(LoginDTO model)
        {
            var resonse = await _httpClient.PostAsJsonAsync($"{BASE_URL}/login", model);
            var result = await resonse.Content.ReadFromJsonAsync<LoginResponse>();
            return result;
        }

        public async Task<RegistrationResonse> RegisterAsync(RegisterDTO model)
        {
            var resonse = await _httpClient.PostAsJsonAsync($"{BASE_URL}/register", model);
            var result = await resonse.Content.ReadFromJsonAsync<RegistrationResonse>();
            return result;
        }

        public async Task<WeatherForecastDTO[]> GetWeatherForecastsAync()
            => await _httpClient.GetFromJsonAsync<WeatherForecastDTO[]>($"{BASE_URL}/weather");


    }
}
